Attribute VB_Name = "DLLDef"
'====================================================================
' Apci9131.bas -- user application interface
'--------------------------------------------------------------------
' Copyright (C) ADTEK System Science Co., Ltd.
'====================================================================
Option Explicit

'--------------------------------------------------------------------
' G[R[h
'--------------------------------------------------------------------
Global Const APCI9131_SUCCESS = 0               ' ُȂ (I)
Global Const APCI9131_ERR_SYSTEM = 1            ' VXeG[
Global Const APCI9131_ERR_NO_DEVICE = 2         ' gp\ȃfoCX܂
Global Const APCI9131_ERR_IN_USE = 3            ' w̃foCX͎gpł
Global Const APCI9131_ERR_INVALID_BSN = 4       '  BSN lł
Global Const APCI9131_ERR_RESOURCE = 5          ' \[XG[
Global Const APCI9131_ERR_INVALID_ARGUMENT = 6  ' sȈv܂

Global Const APCI9131_ERR_REGION = 10           ' sȗ̈w
Global Const APCI9131_ERR_OFFSET = 11           ' sȃItZbgw
'--------------------------------------------------------------------
' ̑̒萔
'--------------------------------------------------------------------
Global Const APCI9131_BSN_AUTO = &HFFFF
Global Const APCI9131_MAX_SLOTS = 16
Global Const APCI9131_MAX_IO = 6
'--------------------------------------------------------------------
' o̓|[gWX^
'--------------------------------------------------------------------
Global Const APCI9131_PORT1 = &H0
Global Const APCI9131_PORT2 = &H1
Global Const APCI9131_PORT3 = &H2
Global Const APCI9131_PORT4 = &H3
Global Const APCI9131_PORT5 = &H4
Global Const APCI9131_PORT6 = &H5
Global Const APCI9131_PORT7 = &H6
Global Const APCI9131_PORT8 = &H7
'--------------------------------------------------------------------
' tB^^CWX^
'--------------------------------------------------------------------
Global Const APCI9131_F_PORT1 = &H8
Global Const APCI9131_F_PORT2 = &H9
Global Const APCI9131_F_PORT3 = &HA
Global Const APCI9131_F_PORT4 = &HB
Global Const APCI9131_F_PORT5 = &HC
Global Const APCI9131_F_PORT6 = &HD
Global Const APCI9131_F_PORT7 = &HE
Global Const APCI9131_F_PORT8 = &HF
Global Const APCI9131_F_STB_ACK = &H10
'--------------------------------------------------------------------
' 荞ݒʒm
'--------------------------------------------------------------------
Global Const APCI9131_MSG_TIMER = 0
Global Const APCI9131_MSG_PORT = 1
Global Const APCI9131_MSG_IACK = 2
Global Const APCI9131_MSG_ISTB = 3
'--------------------------------------------------------------------
' \[X\
'--------------------------------------------------------------------
Type APCI9131RESOURCE
    dwNumIoRegion As Long                       ' I/O ̈搔
    dwIoBase(1 To APCI9131_MAX_IO) As Long      ' I/O |[gx[X
    dwIoLength(1 To APCI9131_MAX_IO) As Long    ' I/O |[g
    dwIrq As Long                               ' 荞ݔԍ
End Type

'--------------------------------------------------------------------
' API
'--------------------------------------------------------------------
Declare Function Apci9131GetVersion Lib "Apci9131" (ByRef pdwDllVersion As Long, ByRef pdwDrvVersion As Long) As Boolean
Declare Function Apci9131Create Lib "Apci9131" (ByRef pwBsn As Integer, ByVal hWnd As Long, ByVal uWMBase As Long) As Boolean
Declare Function Apci9131Close Lib "Apci9131" (ByVal wBsn As Integer) As Boolean
Declare Function Apci9131GetResource Lib "Apci9131" (ByVal wBsn As Integer, ByRef pRes As APCI9131RESOURCE) As Boolean
Declare Function Apci9131GetSwitchValue Lib "Apci9131" (ByVal wBsn As Integer, ByRef pbValue As Byte) As Boolean
Declare Function Apci9131Initialize Lib "Apci9131" (ByVal wBsn As Integer) As Boolean
Declare Function Apci9131SetTimer Lib "Apci9131" (ByVal wBsn As Integer, ByVal dwCount As Long) As Boolean
Declare Function Apci9131Inportb Lib "Apci9131" (ByVal wBsn As Integer, ByVal dwPort As Long, ByRef pData As Byte) As Boolean
Declare Function Apci9131Outportb Lib "Apci9131" (ByVal wBsn As Integer, ByVal dwPort As Long, ByVal Data As Byte) As Boolean
Declare Function Apci9131SetFilter Lib "Apci9131" (ByVal wBsn As Integer, ByVal dwPort As Long, ByVal Cnt As Byte) As Boolean
Declare Function Apci9131GetFilter Lib "Apci9131" (ByVal wBsn As Integer, ByVal dwPort As Long, ByRef pCnt As Byte) As Boolean
Declare Function Apci9131SetIrPolarity Lib "Apci9131" (ByVal wBsn As Integer, ByVal Pol As Byte) As Boolean
Declare Function Apci9131GetIrPolarity Lib "Apci9131" (ByVal wBsn As Integer, ByRef pPol As Byte) As Boolean
Declare Function Apci9131SetPortIr Lib "Apci9131" (ByVal wBsn As Integer, ByVal Ir As Byte) As Boolean
Declare Function Apci9131GetPortIr Lib "Apci9131" (ByVal wBsn As Integer, ByRef pIr As Byte) As Boolean
Declare Function Apci9131SetStbAckIr Lib "Apci9131" (ByVal wBsn As Integer, ByVal Ir As Byte) As Boolean
Declare Function Apci9131GetStbAckIr Lib "Apci9131" (ByVal wBsn As Integer, ByRef pIr As Byte) As Boolean
Declare Function Apci9131SetStbEnableRegs Lib "Apci9131" (ByVal wBsn As Integer, ByVal Sen As Byte) As Boolean
Declare Function Apci9131GetStbEnableRegs Lib "Apci9131" (ByVal wBsn As Integer, ByRef pSen As Byte) As Boolean
Declare Function Apci9131SetAckMode Lib "Apci9131" (ByVal wBsn As Integer, ByVal Ackm As Byte) As Boolean
Declare Function Apci9131GetAckMode Lib "Apci9131" (ByVal wBsn As Integer, ByRef pAckm As Byte) As Boolean
Declare Function Apci9131SetLedRegs Lib "Apci9131" (ByVal wBsn As Integer, ByVal Led As Byte) As Boolean
Declare Function Apci9131GetLedRegs Lib "Apci9131" (ByVal wBsn As Integer, ByRef pLed As Byte) As Boolean
Declare Function Apci9131StbOut Lib "Apci9131" (ByVal wBsn As Integer, ByVal Stb As Byte) As Boolean
Declare Function Apci9131AckOut Lib "Apci9131" (ByVal wBsn As Integer, ByVal Ack As Byte) As Boolean
Declare Function Apci9131GetLastError Lib "Apci9131" (ByVal wBsn As Integer) As Long

