Attribute VB_Name = "Wrapper"
'====================================================================
' Apci9131w.bas -- DLL Wrapper
'--------------------------------------------------------------------
' Copyright (C) ADTEK System Science Co., Ltd.
'====================================================================
Option Explicit

Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const APCI9131_DLL_NAME = "Apci9131.dll" ' DLL t@C
Global Const APCI9131_ERR_WRAPDLL = -1			' bp[֐G[

Dim hDLL As Long								' DLL nh

'====================================================================
'   	DLL [h (񃍁[h̓G[Ƃ)
'   	Ȃ
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wDllOpen() As Boolean
	Apci9131wDllOpen = False
	If hDLL = 0 Then
		hDLL = LoadLibrary(APCI9131_DLL_NAME)
		If hDLL <> 0 Then
			Apci9131wDllOpen = Apci9131GetDllExportFunc()
			If Apci9131wDllOpen <> True Then
				Apci9131wDllClose		' DLL ֐擾Ɏŝ DLL N[Y
			End If
		End If
	End If
End Function
'====================================================================
'   	DLL A[h (A[h̓G[Ƃ)
'   	Ȃ
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wDllClose() As Boolean
	Apci9131wDllClose = False
	If hDLL <> 0 Then
		If FreeLibrary(hDLL) <> 0 Then
			hDLL = 0
			Apci9131wDllClose = True
		End If
	End If
End Function
'====================================================================
'   	DLLADriver ̃o[W擾
'   	pdwDllVersion	DLL o[Wԍi[̈
' @@@	pdwDrvVersion	Driver o[Wԍi[̈
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wGetVersion(ByRef pdwDllVersion As Long, ByRef pdwDrvVersion As Long) As Boolean
	Apci9131wGetVersion = False
	If hDLL <> 0 Then
		If Apci9131GetVersion(pdwDllVersion, pdwDrvVersion) <> 0 Then
			Apci9131wGetVersion = True
		End If
	End If
End Function
'====================================================================
'   	foCXgp錾
'   	pwBsn	gpfoCX BSN li[̈
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wCreate(ByRef pwBsn As Integer, ByVal hWnd As Long, ByVal uWMBase As Long) As Boolean
	Apci9131wCreate = False
	If hDLL <> 0 Then
		If Apci9131Create(pwBsn, hWnd, uWMBase) <> 0 Then
			Apci9131wCreate = True
		End If
	End If
End Function
'====================================================================
'   	foCXJ
'   	wBsn	foCX BSN l
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wClose(ByVal wBsn As Integer) As Boolean
	Apci9131wClose = False
	If hDLL <> 0 Then
		If Apci9131Close(wBsn) <> 0 Then
			Apci9131wClose = True
		End If
	End If
End Function
'====================================================================
'   	\[X擾
'   	wBsn	foCX BSN l
' @@@	pRes	\[Xi[̈
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wGetResource(ByVal wBsn As Integer, ByRef pRes As APCI9131RESOURCE) As Boolean
	Apci9131wGetResource = False
	If hDLL <> 0 Then
		If Apci9131GetResource(wBsn, pRes) <> 0 Then
			Apci9131wGetResource = True
		End If
	End If
End Function
'====================================================================
'   	BSN l擾
'   	wBsn	foCX BSN l
' @@@	pbValue BSN li[̈
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wGetSwitchValue(ByVal wBsn As Integer, ByRef pbValue As Byte) As Boolean
	Apci9131wGetSwitchValue = False
	If hDLL <> 0 Then
		If Apci9131GetSwitchValue(wBsn, pbValue) <> 0 Then
			Apci9131wGetSwitchValue = True
		End If
	End If
End Function
'====================================================================
'   	foCX
'   	wBsn	foCX BSN l
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wInitialize(ByVal wBsn As Integer) As Boolean
	Apci9131wInitialize = False
	If hDLL <> 0 Then
		If Apci9131Initialize(wBsn) <> 0 Then
			Apci9131wInitialize = True
		End If
	End If
End Function
'====================================================================
'   	^C}ݒ
'   	wBsn	foCX BSN l
' @@@	dwCount ^C}荞ݔ
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wSetTimer(ByVal wBsn As Integer, ByVal dwCount As Long) As Boolean
	Apci9131wSetTimer = False
	If hDLL <> 0 Then
		If Apci9131SetTimer(wBsn, dwCount) <> 0 Then
			Apci9131wSetTimer = True
		End If
	End If
End Function
'====================================================================
'   	|[g
'   	wBsn	foCX BSN l
' @@@	dwPort	̓|[gԍ
' @@@	pData	͒li[̈
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wInportb(ByVal wBsn As Integer, ByVal dwPort As Long, ByRef pData As Byte) As Boolean
	Apci9131wInportb = False
	If hDLL <> 0 Then
		If Apci9131Inportb(wBsn, dwPort, pData) <> 0 Then
			Apci9131wInportb = True
		End If
	End If
End Function
'====================================================================
'   	|[go
'   	wBsn	foCX BSN l
' @@@	dwPort	o̓|[gԍ
' @@@	Data	o͒l
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wOutportb(ByVal wBsn As Integer, ByVal dwPort As Long, ByVal Data As Byte) As Boolean
	Apci9131wOutportb = False
	If hDLL <> 0 Then
		If Apci9131Outportb(wBsn, dwPort, Data) <> 0 Then
			Apci9131wOutportb = True
		End If
	End If
End Function
'====================================================================
'   	̓|[g/STB_IN/ACK_IN tB^^Cݒ
'   	wBsn	foCX BSN l
' @@@	dwPort	ݒΏۂ̃|[gԍ
' @@@	Cnt		JE^wl
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wSetFilter(ByVal wBsn As Integer, ByVal dwPort As Long, ByVal Cnt As Byte) As Boolean
	Apci9131wSetFilter = False
	If hDLL <> 0 Then
		If Apci9131SetFilter(wBsn, dwPort, Cnt) <> 0 Then
			Apci9131wSetFilter = True
		End If
	End If
End Function
'====================================================================
'   	̓|[g/STB_IN/ACK_IN tB^^Cݒl擾
'   	wBsn	foCX BSN l
' @@@	dwPort	ݒΏۂ̃|[gԍ
' @@@	pCnt	JE^wli[̈
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wGetFilter(ByVal wBsn As Integer, ByVal dwPort As Long, ByRef pCnt As Byte) As Boolean
	Apci9131wGetFilter = False
	If hDLL <> 0 Then
		If Apci9131GetFilter(wBsn, dwPort, pCnt) <> 0 Then
			Apci9131wGetFilter = True
		End If
	End If
End Function
'====================================================================
'   	荞݃|eBݒ
'   	wBsn	foCX BSN l
' @@@	Pol		͊荞݃|eBWX^ݒl
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wSetIrPolarity(ByVal wBsn As Integer, ByVal Pol As Byte) As Boolean
	Apci9131wSetIrPolarity = False
	If hDLL <> 0 Then
		If Apci9131SetIrPolarity(wBsn, Pol) <> 0 Then
			Apci9131wSetIrPolarity = True
		End If
	End If
End Function
'====================================================================
'   	荞݃|eBݒl擾
'   	wBsn	foCX BSN l
' @@@	pPol	͊荞݃|eBWX^ݒli[̈
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wGetIrPolarity(ByVal wBsn As Integer, ByRef pPol As Byte) As Boolean
	Apci9131wGetIrPolarity = False
	If hDLL <> 0 Then
		If Apci9131GetIrPolarity(wBsn, pPol) <> 0 Then
			Apci9131wGetIrPolarity = True
		End If
	End If
End Function
'====================================================================
'   	̓|[g荞ݐݒ
'   	wBsn	foCX BSN l
' @@@	Ir		荞݃Cl[uWX^ (̓|[g) ݒl
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wSetPortIr(ByVal wBsn As Integer, ByVal Ir As Byte) As Boolean
	Apci9131wSetPortIr = False
	If hDLL <> 0 Then
		If Apci9131SetPortIr(wBsn, Ir) <> 0 Then
			Apci9131wSetPortIr = True
		End If
	End If
End Function
'====================================================================
'   	̓|[g荞ݐݒl擾
'   	wBsn	foCX BSN l
' @@@	pIr		荞݃Cl[uWX^ (̓|[g) ݒl
' @@@			i[̈
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wGetPortIr(ByVal wBsn As Integer, ByRef pIr As Byte) As Boolean
	Apci9131wGetPortIr = False
	If hDLL <> 0 Then
		If Apci9131GetPortIr(wBsn, pIr) <> 0 Then
			Apci9131wGetPortIr = True
		End If
	End If
End Function
'====================================================================
'   	STB/ACK 荞ݐݒ
'   	wBsn	foCX BSN l
' @@@	Ir		荞݃Cl[uWX^ (STB/ACK) ݒl
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wSetStbAckIr(ByVal wBsn As Integer, ByVal Ir As Byte) As Boolean
	Apci9131wSetStbAckIr = False
	If hDLL <> 0 Then
		If Apci9131SetStbAckIr(wBsn, Ir) <> 0 Then
			Apci9131wSetStbAckIr = True
		End If
	End If
End Function
'====================================================================
'   	STB/ACK 荞ݐݒl擾
'   	wBsn	foCX BSN l
' @@@	pIr		荞݃Cl[uWX^ (STB/ACK) ݒl
' @@@			i[̈
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wGetStbAckIr(ByVal wBsn As Integer, ByRef pIr As Byte) As Boolean
	Apci9131wGetStbAckIr = False
	If hDLL <> 0 Then
		If Apci9131GetStbAckIr(wBsn, pIr) <> 0 Then
			Apci9131wGetStbAckIr = True
		End If
	End If
End Function
'====================================================================
'   	STB_IN Cl[uWX^ݒ
'   	wBsn	foCX BSN l
' @@@	Sen		STB_IN Cl[uWX^ݒl
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wSetStbEnableRegs(ByVal wBsn As Integer, ByVal Sen As Byte) As Boolean
	Apci9131wSetStbEnableRegs = False
	If hDLL <> 0 Then
		If Apci9131SetStbEnableRegs(wBsn, Sen) <> 0 Then
			Apci9131wSetStbEnableRegs = True
		End If
	End If
End Function
'====================================================================
'   	STB_IN Cl[uWX^ݒl擾
'   	wBsn	foCX BSN l
' @@@	pSen	STB_IN Cl[uWX^ݒli[̈
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wGetStbEnableRegs(ByVal wBsn As Integer, ByRef pSen As Byte) As Boolean
	Apci9131wGetStbEnableRegs = False
	If hDLL <> 0 Then
		If Apci9131GetStbEnableRegs(wBsn, pSen) <> 0 Then
			Apci9131wGetStbEnableRegs = True
		End If
	End If
End Function
'====================================================================
'   	ACK/RDY [hWX^ݒ
'   	wBsn	foCX BSN l
' @@@	Ackm	ACK/BUSY [hWX^ݒl
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wSetAckMode(ByVal wBsn As Integer, ByVal Ackm As Byte) As Boolean
	Apci9131wSetAckMode = False
	If hDLL <> 0 Then
		If Apci9131SetAckMode(wBsn, Ackm) <> 0 Then
			Apci9131wSetAckMode = True
		End If
	End If
End Function
'====================================================================
'   	ACK/RDY [hWX^ݒl擾
'   	wBsn	foCX BSN l
' @@@	pAckm	ACK/BUSY [hWX^ݒli[̈
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wGetAckMode(ByVal wBsn As Integer, ByRef pAckm As Byte) As Boolean
	Apci9131wGetAckMode = False
	If hDLL <> 0 Then
		If Apci9131GetAckMode(wBsn, pAckm) <> 0 Then
			Apci9131wGetAckMode = True
		End If
	End If
End Function
'====================================================================
'   	LED 䃌WX^ݒ
'   	wBsn	foCX BSN l
' @@@	Led		LED 䃌WX^ݒl
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wSetLedRegs(ByVal wBsn As Integer, ByVal Led As Byte) As Boolean
	Apci9131wSetLedRegs = False
	If hDLL <> 0 Then
		If Apci9131SetLedRegs(wBsn, Led) <> 0 Then
			Apci9131wSetLedRegs = True
		End If
	End If
End Function
'====================================================================
'   	LED 䃌WX^ݒl擾
'   	wBsn	foCX BSN l
' @@@	pLed	LED 䃌WX^ݒli[̈
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wGetLedRegs(ByVal wBsn As Integer, ByRef pLed As Byte) As Boolean
	Apci9131wGetLedRegs = False
	If hDLL <> 0 Then
		If Apci9131GetLedRegs(wBsn, pLed) <> 0 Then
			Apci9131wGetLedRegs = True
		End If
	End If
End Function
'====================================================================
'   	STB o
'   	wBsn	foCX BSN l
' @@@	Stb		STB o͒l
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wStbOut(ByVal wBsn As Integer, ByVal Stb As Byte) As Boolean
	Apci9131wStbOut = False
	If hDLL <> 0 Then
		If Apci9131StbOut(wBsn, Stb) <> 0 Then
			Apci9131wStbOut = True
		End If
	End If
End Function
'====================================================================
'   	ACK o
'   	wBsn	foCX BSN l
' @@@	Ack		ACK o͒l
' ߂l		True
' @@@	s	False
'====================================================================
Function Apci9131wAckOut(ByVal wBsn As Integer, ByVal Ack As Byte) As Boolean
	Apci9131wAckOut = False
	If hDLL <> 0 Then
		If Apci9131AckOut(wBsn, Ack) <> 0 Then
			Apci9131wAckOut = True
		End If
	End If
End Function
'====================================================================
'   	G[擾
'   	wBsn	foCX BSN l
' ߂l	G[
'====================================================================
Function Apci9131wGetLastError(ByVal wBsn As Integer) As Long
	If hDLL = 0 Then
		Apci9131wGetLastError = APCI9131_ERR_WRAPDLL
	Else
		Apci9131wGetLastError = Apci9131GetLastError(wBsn)
	End If
End Function

'--------------------------------------------------------------------
'   	DLL GNX|[g֐AhX̎擾
'   	Ȃ
' ߂l		True
' @@@	s	False
'--------------------------------------------------------------------
Private Function Apci9131GetDllExportFunc() As Boolean
	Dim pFunc As Long
	
		Apci9131GetDllExportFunc = False
		
		pFunc = GetProcAddress(hDLL, "Apci9131GetVersion")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131Create")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131Close")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131GetResource")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131GetSwitchValue")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131Initialize")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131SetTimer")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131Inportb")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131Outportb")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131SetFilter")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131GetFilter")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131SetIrPolarity")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131GetIrPolarity")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131SetPortIr")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131GetPortIr")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131SetStbAckIr")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131GetStbAckIr")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131SetStbEnableRegs")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131GetStbEnableRegs")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131SetAckMode")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131GetAckMode")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131SetLedRegs")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131GetLedRegs")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131StbOut")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131AckOut")
		If pFunc = 0 Then Exit Function
		pFunc = GetProcAddress(hDLL, "Apci9131GetLastError")
		If pFunc = 0 Then Exit Function
		
		' ׂĂ DLL GNX|[g֐AhX擾 OK
		Apci9131GetDllExportFunc = True
		
End Function
