Attribute VB_Name = "Sample"
'====================================================================
' Apci9131s.bas -- aPCI-9131 
'--------------------------------------------------------------------
' ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
' nhVF[N[hŃ|[g1 ͂Əo͂̃[vobNs܂
'
' Copyright (C) ADTEK System Science Co., Ltd.
'====================================================================
Option Explicit

Public Const szTitle = "Sample"
Public Const GWL_WNDPROC = -4
Public Const WM_USERMES = &H600
Public Const WM_APCI9131 = WM_USERMES + 100
Public Const WM_APCI9131_IACK = WM_APCI9131 + APCI9131_MSG_IACK
Public Const WM_APCI9131_ISTB = WM_APCI9131 + APCI9131_MSG_ISTB

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Global lpPrevWndProc As Long
Global gHW As Long
Global wBsn As Integer
Global szBuf As String
Global IncData As Byte
'====================================================================
' 
'====================================================================
Public Sub OnLoad()
    Dim Ri As APCI9131RESOURCE      ' \[X
    Dim dwDllVer As Long            ' DLL o[W
    Dim dwDrvVer As Long            ' Driver o[W
    Dim bSwVal As Byte              ' BSN l
    
    wBsn = APCI9131_BSN_AUTO
    IncData = 0
    '----------------------------------------------------------------
    ' DLL gp錾
    '----------------------------------------------------------------
    If Apci9131wDllOpen() = False Then
        ErrorMessage (APCI9131_BSN_AUTO)
        Exit Sub
    End If
    ResultMessage ("DLL [h܂")
    '----------------------------------------------------------------
    ' o[W擾
    '----------------------------------------------------------------
    If Apci9131wGetVersion(dwDllVer, dwDrvVer) = False Then
        ErrorMessage (APCI9131_BSN_AUTO)
        Exit Sub
    End If
    szBuf = "GetVersion" + Chr(10) + _
            "DLL Version" + Chr(9) + ": &H" + Hex(dwDllVer) + Chr(10) + _
            "Driver Version" + Chr(9) + ": &H" + Hex(dwDrvVer) + Chr(10)
    ResultMessage (szBuf)
    '----------------------------------------------------------------
    ' foCXgp錾
    '----------------------------------------------------------------
    If Apci9131wCreate(wBsn, gHW, WM_APCI9131) = False Then
        ErrorMessage (APCI9131_BSN_AUTO)
        Exit Sub
    End If
    ResultMessage ("aPCI-9131 Create")
    '-----------------------------------------------------------------
    ' \[X BSN l擾
    '-----------------------------------------------------------------
    If Apci9131wGetResource(wBsn, Ri) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    If Apci9131wGetSwitchValue(wBsn, bSwVal) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    szBuf = "APIC21 I/O Address" + Chr(9) + ": &H" + Hex(Ri.dwIoBase(1)) + _
            " - &H" + Hex(Ri.dwIoBase(1) + Ri.dwIoLength(1) - 1) + Chr(10) + _
            "Device I/O Address" + Chr(9) + ": &H" + Hex(Ri.dwIoBase(2)) + _
            " - &H" + Hex(Ri.dwIoBase(2) + Ri.dwIoLength(2) - 1) + Chr(10) + _
            "IRQ Number" + Chr(9) + ":" + Str(Ri.dwIrq) + Chr(10) + _
            "BSN Value" + Chr(9) + ": &H" + Hex(bSwVal)
    ResultMessage (szBuf)
    '-----------------------------------------------------------------
    ' eWX^ɏlݒ
    '-----------------------------------------------------------------
    RegInit
    '-----------------------------------------------------------------
    ' ̓|[g1 ݂̂nhVF[N[hɐݒ
    '-----------------------------------------------------------------
    If Apci9131wSetStbEnableRegs(wBsn, &H1) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    ResultMessage ("̓|[g1 nhVF[N[hɐݒ肵܂")
    '-----------------------------------------------------------------
    ' STB/ACK ̊݃Cl[u
    '-----------------------------------------------------------------
    If Apci9131wSetStbAckIr(wBsn, &H11) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    ResultMessage ("STB/ACK ̊荞݂Lɂ܂")
    '-----------------------------------------------------------------
    ' |[g1 Ƀf[^Zbg
    '-----------------------------------------------------------------
    If Apci9131wOutportb(wBsn, APCI9131_PORT1, IncData) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    ResultMessage ("|[g1 Ƀf[^Zbg܂")
    '-----------------------------------------------------------------
    ' STB o
    '-----------------------------------------------------------------
    If Apci9131wStbOut(wBsn, &H1) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    ResultMessage ("STB o͂܂")
End Sub
'====================================================================
' I
'====================================================================
Public Sub OnUnLoad()
    If IncData < 10 Then
        DataShow
    End If
    '----------------------------------------------------------------
    ' foCXgpJ
    '----------------------------------------------------------------
    If Apci9131wClose(wBsn) = True Then
        ResultMessage ("aPCI-9131 Close")
    End If
    '----------------------------------------------------------------
    ' DLL gpJ
    '----------------------------------------------------------------
    If Apci9131wDllClose() = True Then
        ResultMessage ("DLL A[h܂")
    End If
End Sub
'====================================================================
' f[^\
'====================================================================
Private Sub DataShow()
    '----------------------------------------------------------------
    ' STB/ACK ̊݃fBZ[u
    '----------------------------------------------------------------
    If Apci9131wSetStbAckIr(wBsn, &H0) = True Then
        ResultMessage ("STB/ACK ̊荞݂𖳌ɂ܂")
    End If
    '----------------------------------------------------------------
    ' ̓|[g1 ̃nhVF[N[h
    '----------------------------------------------------------------
    If Apci9131wSetStbEnableRegs(wBsn, &H0) = True Then
        ResultMessage ("̓|[g1 ̃nhVF[N[h܂")
    End If
    '----------------------------------------------------------------
    ' CNgf[^\
    '----------------------------------------------------------------
    szBuf = "CNgf[^ = " + Str(IncData)
    ResultMessage (szBuf)
End Sub
'====================================================================
' lݒ
'====================================================================
Private Sub RegInit()
    '----------------------------------------------------------------
    ' o̓|[gWX^1
    '----------------------------------------------------------------
    If Apci9131wOutportb(wBsn, APCI9131_PORT1, &H0) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    '----------------------------------------------------------------
    ' STB_IN Cl[uWX^ (P̓[h)
    '----------------------------------------------------------------
    If Apci9131wSetStbEnableRegs(wBsn, &H0) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    '----------------------------------------------------------------
    ' STB/ACK 荞݃Cl[uWX^ (荞݋֎~)
    '----------------------------------------------------------------
    If Apci9131wSetStbAckIr(wBsn, &H0) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    '----------------------------------------------------------------
    ' STB o
    '----------------------------------------------------------------
    If Apci9131wStbOut(wBsn, &H0) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
End Sub
'====================================================================
' EBhEbZ[W
'====================================================================
Function WindowProc(ByVal hw As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim strbuf As String
    
    If uMsg = WM_APCI9131_IACK Then
        OnAck (CInt(wParam))
        Exit Function
    End If

    If uMsg = WM_APCI9131_ISTB Then
        OnStb (CInt(wParam))
        Exit Function
    End If

    WindowProc = CallWindowProc(lpPrevWndProc, hw, uMsg, wParam, lParam)
End Function
'====================================================================
' ACK 荞ݏ
'====================================================================
Function OnAck(ByVal bsn As Integer)
    '----------------------------------------------------------------
    ' CNgf[^ 10 ɂȂI
    '----------------------------------------------------------------
    If IncData < 10 Then
        IncData = IncData + 1
        '----------------------------------------------------------------
        ' |[g1 Ƀf[^Zbg
        '----------------------------------------------------------------
        If Apci9131wOutportb(bsn, APCI9131_PORT1, IncData) = False Then
            ErrorMessage (bsn)
            Exit Function
        End If
        '----------------------------------------------------------------
        ' Sleep (100ms)
        '----------------------------------------------------------------
        Sleep (100)
        '----------------------------------------------------------------
        ' STB o
        '----------------------------------------------------------------
        If Apci9131wStbOut(bsn, &H1) = False Then
            ErrorMessage (bsn)
            Exit Function
        End If
    Else
        DataShow
    End If
End Function
'====================================================================
' STB 荞ݏ
'====================================================================
Function OnStb(ByVal bsn As Integer)
    '----------------------------------------------------------------
    ' |[g1 ̃f[^ǂݍ
    '----------------------------------------------------------------
    If Apci9131wInportb(bsn, APCI9131_PORT1, IncData) = False Then
        ErrorMessage (bsn)
        Exit Function
    End If
    '----------------------------------------------------------------
    ' Sleep (100ms)
    '----------------------------------------------------------------
    Sleep (100)
    '----------------------------------------------------------------
    ' ACK o
    '----------------------------------------------------------------
    If Apci9131wAckOut(bsn, &H1) = False Then
        ErrorMessage (bsn)
        Exit Function
    End If
End Function
'====================================================================
' TuNXs
'====================================================================
Public Sub Hook()
    lpPrevWndProc = SetWindowLong(gHW, GWL_WNDPROC, AddressOf WindowProc)
End Sub
'====================================================================
' TuNX
'====================================================================
Public Sub Unhook()
    Dim temp As Long
    temp = SetWindowLong(gHW, GWL_WNDPROC, lpPrevWndProc)
End Sub
'====================================================================
' ʂ\
'====================================================================
Private Sub ResultMessage(lpszbuf As String)
    MsgBox lpszbuf, vbOKOnly + vbInformation, szTitle
End Sub
'====================================================================
' G[bZ[W\
'====================================================================
Private Sub ErrorMessage(ByVal bsn As Integer)
    Dim dwRes As Long
    Dim szBuf As String
    
    dwRes = Apci9131wGetLastError(bsn)
    Select Case dwRes
        Case APCI9131_ERR_WRAPDLL
            szBuf = "DLL Load error"
        Case Else
            szBuf = "aPCI-9131 error" + Chr(10) + Chr(10) + _
                    "Error code : &H" + Hex(dwRes)
    End Select
    
    MsgBox szBuf, vbOKOnly + vbCritical, szTitle
End Sub
