Attribute VB_Name = "Sample"
'====================================================================
' Apci9131s.bas -- aPCI-9131 
'--------------------------------------------------------------------
' ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
' ̓|[g荞݂ƃ^C}荞ݎgpł
'
' Copyright (C) ADTEK System Science Co., Ltd.
'====================================================================
Option Explicit

Public Const szTitle = "Sample"
Public Const GWL_WNDPROC = -4
Public Const WM_USERMES = &H600
Public Const WM_APCI9131 = WM_USERMES + 100
Public Const WM_APCI9131_TIMER = WM_APCI9131 + APCI9131_MSG_TIMER
Public Const WM_APCI9131_PORT = WM_APCI9131 + APCI9131_MSG_PORT

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Global lpPrevWndProc As Long
Global gHW As Long
Global wBsn As Integer
Global szBuf As String
Global TimerCnt As Long
Global PortIrCnt(0 To 7) As Long
'====================================================================
' 
'====================================================================
Public Sub OnLoad()
    Dim Ri As APCI9131RESOURCE      ' \[X
    Dim dwDllVer As Long            ' DLL o[W
    Dim dwDrvVer As Long            ' Driver o[W
    Dim bSwVal As Byte              ' BSN l
    Dim bTimer As Byte              ' ^C}荞ݎ
    Dim i As Integer

    wBsn = APCI9131_BSN_AUTO
    TimerCnt = 0
    For i = 0 To 7
        PortIrCnt(i) = 0
    Next i
    '----------------------------------------------------------------
    ' DLL gp錾
    '----------------------------------------------------------------
    If Apci9131wDllOpen() = False Then
        ErrorMessage (APCI9131_BSN_AUTO)
        Exit Sub
    End If
    ResultMessage ("DLL [h܂")
    '----------------------------------------------------------------
    ' o[W擾
    '----------------------------------------------------------------
    If Apci9131wGetVersion(dwDllVer, dwDrvVer) = False Then
        ErrorMessage (APCI9131_BSN_AUTO)
        Exit Sub
    End If
    szBuf = "GetVersion" + Chr(10) + _
            "DLL Version" + Chr(9) + ": &H" + Hex(dwDllVer) + Chr(10) + _
            "Driver Version" + Chr(9) + ": &H" + Hex(dwDrvVer) + Chr(10)
    ResultMessage (szBuf)
    '----------------------------------------------------------------
    ' foCXgp錾
    '----------------------------------------------------------------
    If Apci9131wCreate(wBsn, gHW, WM_APCI9131) = False Then
        ErrorMessage (APCI9131_BSN_AUTO)
        Exit Sub
    End If
    ResultMessage ("aPCI-9131 Create")
    '-----------------------------------------------------------------
    ' \[X BSN l擾
    '-----------------------------------------------------------------
    If Apci9131wGetResource(wBsn, Ri) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    If Apci9131wGetSwitchValue(wBsn, bSwVal) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    szBuf = "APIC21 I/O Address" + Chr(9) + ": &H" + Hex(Ri.dwIoBase(1)) + _
            " - &H" + Hex(Ri.dwIoBase(1) + Ri.dwIoLength(1) - 1) + Chr(10) + _
            "Device I/O Address" + Chr(9) + ": &H" + Hex(Ri.dwIoBase(2)) + _
            " - &H" + Hex(Ri.dwIoBase(2) + Ri.dwIoLength(2) - 1) + Chr(10) + _
            "IRQ Number" + Chr(9) + ":" + Str(Ri.dwIrq) + Chr(10) + _
            "BSN Value" + Chr(9) + ": &H" + Hex(bSwVal)
    ResultMessage (szBuf)
    '-----------------------------------------------------------------
    ' eWX^ɏlݒ
    '-----------------------------------------------------------------
    RegInit
    '-----------------------------------------------------------------
    ' ̓|[g荞݃|eBݒ
    ' SẴ|[g̓tHgJv OFF ON ̕ω (オGbW) 
    ' 荞ݔ
    '-----------------------------------------------------------------
    If Apci9131wSetIrPolarity(wBsn, &HFF) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    ResultMessage ("̓|[g荞݃|eBݒ肵܂")
    '-----------------------------------------------------------------
    ' SĂ̓̓|[g荞݂Cl[u
    '-----------------------------------------------------------------
    If Apci9131wSetPortIr(wBsn, &HFF) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    ResultMessage ("̓|[g̊荞݂Lɂ܂")
    '-----------------------------------------------------------------
    ' ^C}N (100ms)
    '-----------------------------------------------------------------
    bTimer = 100
    If Apci9131wSetTimer(wBsn, bTimer) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    szBuf = "^C}N܂" + Chr(10) + _
            "荞ݔ : " + Str(bTimer) + "ms"
    ResultMessage (szBuf)
End Sub
'====================================================================
' I
'====================================================================
Public Sub OnUnLoad()
    If TimerCnt < 20 Then
        DataShow
    End If
    '----------------------------------------------------------------
    ' foCXgpJ
    '----------------------------------------------------------------
    If Apci9131wClose(wBsn) = True Then
        ResultMessage ("aPCI-9131 Close")
    End If
    '----------------------------------------------------------------
    ' DLL gpJ
    '----------------------------------------------------------------
    If Apci9131wDllClose() = True Then
        ResultMessage ("DLL A[h܂")
    End If
End Sub
'====================================================================
' f[^\
'====================================================================
Private Sub DataShow()
    '----------------------------------------------------------------
    ' ^C}~
    '----------------------------------------------------------------
    If Apci9131wSetTimer(wBsn, 0) = True Then
        ResultMessage ("^C}荞݂𖳌ɂ܂")
    End If
    '----------------------------------------------------------------
    ' SĂ̓̓|[g荞݂fBZ[u
    '----------------------------------------------------------------
    If Apci9131wSetPortIr(wBsn, &H0) = True Then
        ResultMessage ("̓|[g̊荞݂𖳌ɂ܂")
    End If
    '----------------------------------------------------------------
    ' CNgf[^\
    '----------------------------------------------------------------
    szBuf = "^C}ݔ : " + Str(TimerCnt) + Chr(10) + _
            "̓|[g1 ݔ : " + Str(PortIrCnt(0)) + Chr(10) + _
            "̓|[g2 ݔ : " + Str(PortIrCnt(1)) + Chr(10) + _
            "̓|[g3 ݔ : " + Str(PortIrCnt(2)) + Chr(10) + _
            "̓|[g4 ݔ : " + Str(PortIrCnt(3)) + Chr(10) + _
            "̓|[g5 ݔ : " + Str(PortIrCnt(4)) + Chr(10) + _
            "̓|[g6 ݔ : " + Str(PortIrCnt(5)) + Chr(10) + _
            "̓|[g7 ݔ : " + Str(PortIrCnt(6)) + Chr(10) + _
            "̓|[g8 ݔ : " + Str(PortIrCnt(7)) + Chr(10)
    ResultMessage (szBuf)
End Sub
'====================================================================
' lݒ
'====================================================================
Private Sub RegInit()
    '-----------------------------------------------------------------
    ' ̓|[g荞݃|eBWX^
    '-----------------------------------------------------------------
    If Apci9131wSetIrPolarity(wBsn, &H0) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    '-----------------------------------------------------------------
    ' ̓|[g荞݃Cl[uWX^ (荞݋֎~)
    '-----------------------------------------------------------------
    If Apci9131wSetPortIr(wBsn, &H0) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    '-----------------------------------------------------------------
    ' ^C}荞 (gp)
    '-----------------------------------------------------------------
    If Apci9131wSetTimer(wBsn, &H0) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
End Sub
'====================================================================
' EBhEbZ[W
'====================================================================
Function WindowProc(ByVal hw As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim strbuf As String
    
    If uMsg = WM_APCI9131_TIMER Then
        OnTimer (CInt(wParam))
        Exit Function
    End If

    If uMsg = WM_APCI9131_PORT Then
        OnPortIr (CInt(wParam)), (CLng(lParam))
        Exit Function
    End If

    WindowProc = CallWindowProc(lpPrevWndProc, hw, uMsg, wParam, lParam)
End Function
'====================================================================
' ^C}荞ݏ
'====================================================================
Function OnTimer(ByVal bsn As Integer)
    '----------------------------------------------------------------
    ' ^C}荞݉񐔂 20 ɂȂI
    '----------------------------------------------------------------
    If TimerCnt < 20 Then
        TimerCnt = TimerCnt + 1
    Else
        DataShow
    End If
End Function
'====================================================================
' ̓|[g荞݊ݏ
'====================================================================
Function OnPortIr(ByVal bsn As Integer, ByVal lParam As Long)
    If lParam And &H1 Then PortIrCnt(0) = PortIrCnt(0) + 1
    If lParam And &H2 Then PortIrCnt(1) = PortIrCnt(1) + 1
    If lParam And &H4 Then PortIrCnt(2) = PortIrCnt(2) + 1
    If lParam And &H8 Then PortIrCnt(3) = PortIrCnt(3) + 1
    If lParam And &H10 Then PortIrCnt(4) = PortIrCnt(4) + 1
    If lParam And &H20 Then PortIrCnt(5) = PortIrCnt(5) + 1
    If lParam And &H40 Then PortIrCnt(6) = PortIrCnt(6) + 1
    If lParam And &H80 Then PortIrCnt(7) = PortIrCnt(7) + 1
End Function
'====================================================================
' TuNXs
'====================================================================
Public Sub Hook()
    lpPrevWndProc = SetWindowLong(gHW, GWL_WNDPROC, AddressOf WindowProc)
End Sub
'====================================================================
' TuNX
'====================================================================
Public Sub Unhook()
    Dim temp As Long
    temp = SetWindowLong(gHW, GWL_WNDPROC, lpPrevWndProc)
End Sub
'====================================================================
' ʂ\
'====================================================================
Private Sub ResultMessage(lpszbuf As String)
    MsgBox lpszbuf, vbOKOnly + vbInformation, szTitle
End Sub
'====================================================================
' G[bZ[W\
'====================================================================
Private Sub ErrorMessage(ByVal bsn As Integer)
    Dim dwRes As Long
    Dim szBuf As String
    
    dwRes = Apci9131wGetLastError(bsn)
    Select Case dwRes
        Case APCI9131_ERR_WRAPDLL
            szBuf = "DLL Load error"
        Case Else
            szBuf = "aPCI-9131 error" + Chr(10) + Chr(10) + _
                    "Error code : &H" + Hex(dwRes)
    End Select
    
    MsgBox szBuf, vbOKOnly + vbCritical, szTitle
End Sub
