//===================================================================
// Apci9131.h -- user application interface
//-------------------------------------------------------------------
// Copyright (C) ADTEK System Science Co., Ltd.
//===================================================================
#define APCI9131_BSN_AUTO				( (WORD)~0U )
#define APCI9131_MAX_SLOTS				16

//-------------------------------------------------------------------
// o̓|[gWX^
//-------------------------------------------------------------------
#define APCI9131_PORT1					0x00
#define APCI9131_PORT2					0x01
#define APCI9131_PORT3					0x02
#define APCI9131_PORT4					0x03
#define APCI9131_PORT5					0x04
#define APCI9131_PORT6					0x05
#define APCI9131_PORT7					0x06
#define APCI9131_PORT8					0x07
//-------------------------------------------------------------------
// tB^^CWX^
//-------------------------------------------------------------------
#define APCI9131_F_PORT1				0x08
#define APCI9131_F_PORT2				0x09
#define APCI9131_F_PORT3				0x0A
#define APCI9131_F_PORT4				0x0B
#define APCI9131_F_PORT5				0x0C
#define APCI9131_F_PORT6				0x0D
#define APCI9131_F_PORT7				0x0E
#define APCI9131_F_PORT8				0x0F
#define APCI9131_F_STB_ACK				0x10
//-------------------------------------------------------------------
// 荞ݒʒm
//-------------------------------------------------------------------
#define APCI9131_MSG_TIMER				0
#define APCI9131_MSG_PORT				1
#define APCI9131_MSG_IACK				2
#define APCI9131_MSG_ISTB				3
//-------------------------------------------------------------------
// \[X\
//-------------------------------------------------------------------
#define APCI9131_MAX_IO					6

typedef struct APCI9131RESOURCE {
	DWORD	dwNumIoRegion;						// I/O ̈搔
	DWORD	dwIoBase	[ APCI9131_MAX_IO ];	// I/O |[gx[X
	DWORD	dwIoLength	[ APCI9131_MAX_IO ];	// I/O |[g
	DWORD	dwIrq;								// 荞ݔԍ
} APCI9131RESOURCE, *PAPCI9131R;
//-------------------------------------------------------------------
// G[R[h
//-------------------------------------------------------------------
#define APCI9131_SUCCESS				0		// ُȂ (I)
#define APCI9131_ERR_SYSTEM				1		// VXeG[
#define APCI9131_ERR_NO_DEVICE			2		// gp\ȃfoCX܂
#define APCI9131_ERR_IN_USE				3		// w̃foCX͎gpł
#define APCI9131_ERR_INVALID_BSN		4		//  BSN lł
#define APCI9131_ERR_RESOURCE			5		// \[XG[
#define APCI9131_ERR_INVALID_ARGUMENT	6		// sȈw肵܂

#define APCI9131_ERR_REGION				10		// sȗ̈w
#define APCI9131_ERR_OFFSET				11		// sȃItZbgw
