Attribute VB_Name = "Sample"
'====================================================================
' Apci9131s.bas -- aPCI-9131 
'--------------------------------------------------------------------
' ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
' Po (tB^O) s܂
'
' Copyright (C) ADTEK System Science Co., Ltd.
'====================================================================
Option Explicit

Public Const szTitle = "Sample"

Global wBsn As Integer
'====================================================================
' vOJn
'====================================================================
Private Sub Main()
    Dim Ri As APCI9131RESOURCE      ' \[X
    Dim dwDllVer As Long            ' DLL o[W
    Dim dwDrvVer As Long            ' Driver o[W
    Dim bSwVal As Byte              ' BSN l
    Dim bCnt As Byte                ' tB^^CWX^ݒl
    Dim bData As Byte               ' o͒l
    Dim szBuf As String
    
    wBsn = APCI9131_BSN_AUTO
    '----------------------------------------------------------------
    ' DLL gp錾
    '----------------------------------------------------------------
    If Apci9131wDllOpen() = False Then
        ErrorMessage (APCI9131_BSN_AUTO)
        Exit Sub                    ' DLL [hs
    End If
    ResultMessage ("DLL [h܂")
    '----------------------------------------------------------------
    ' o[W擾
    '----------------------------------------------------------------
    If Apci9131wGetVersion(dwDllVer, dwDrvVer) = False Then
        ErrorMessage (APCI9131_BSN_AUTO)
        Exit Sub
    End If
    szBuf = "GetVersion" + Chr(10) + _
            "DLL Version" + Chr(9) + ": &H" + Hex(dwDllVer) + Chr(10) + _
            "Driver Version" + Chr(9) + ": &H" + Hex(dwDrvVer) + Chr(10)
    ResultMessage (szBuf)
    '-----------------------------------------------------------------
    ' foCXgp錾
    '-----------------------------------------------------------------
    If Apci9131wCreate(wBsn, 0, 0) = False Then
        ErrorMessage (APCI9131_BSN_AUTO)
        Exit Sub
    End If
    ResultMessage ("aPCI-9131 Create")
    '-----------------------------------------------------------------
    ' \[X BSN l擾
    '-----------------------------------------------------------------
    If Apci9131wGetResource(wBsn, Ri) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    If Apci9131wGetSwitchValue(wBsn, bSwVal) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    szBuf = "APIC21 I/O Address" + Chr(9) + ": &H" + Hex(Ri.dwIoBase(1)) + _
            " - &H" + Hex(Ri.dwIoBase(1) + Ri.dwIoLength(1) - 1) + Chr(10) + _
            "Device I/O Address" + Chr(9) + ": &H" + Hex(Ri.dwIoBase(2)) + _
            " - &H" + Hex(Ri.dwIoBase(2) + Ri.dwIoLength(2) - 1) + Chr(10) + _
            "IRQ Number" + Chr(9) + ":" + Str(Ri.dwIrq) + Chr(10) + _
            "BSN Value" + Chr(9) + ": &H" + Hex(bSwVal)
    ResultMessage (szBuf)
    '-----------------------------------------------------------------
    ' eWX^ɏlݒ
    '-----------------------------------------------------------------
    RegInit
    '-----------------------------------------------------------------
    ' |[g1 ̃`^OtB^ݒ
    '-----------------------------------------------------------------
    bCnt = 0
    If Apci9131wSetFilter(wBsn, APCI9131_F_PORT1, bCnt) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    szBuf = "|[g1 ̃`^OtB^ݒ肵܂" + Chr(10) + _
            "tB^ : " + Str(bCnt * 10) + "s"
    ResultMessage (szBuf)
    '-----------------------------------------------------------------
    ' |[g1 Ƀf[^
    '-----------------------------------------------------------------
    bData = &HAA
    If Apci9131wOutportb(wBsn, APCI9131_PORT1, bData) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    szBuf = "|[g1 Ƀf[^݂܂" + Chr(10) + _
            "Write Data : &H" + Hex(bData)
    ResultMessage (szBuf)
    '-----------------------------------------------------------------
    ' |[g1 f[^ǂݍ
    '-----------------------------------------------------------------
    bData = &H0
    If Apci9131wInportb(wBsn, APCI9131_PORT1, bData) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    szBuf = "|[g1 f[^ǂݍ݂܂" + Chr(10) + _
            "Read Data : &H" + Hex(bData)
    ResultMessage (szBuf)
    '-----------------------------------------------------------------
    ' foCXgpJ
    '-----------------------------------------------------------------
    If Apci9131wClose(wBsn) = True Then
        ResultMessage ("aPCI-9131 Close")
    End If
    '-----------------------------------------------------------------
    ' DLL gpJ
    '-----------------------------------------------------------------
    If Apci9131wDllClose() = True Then
        ResultMessage ("DLL A[h܂")
    End If
End Sub
'====================================================================
' lݒ
'====================================================================
Private Sub RegInit()
    '----------------------------------------------------------------
    ' o̓|[gWX^1
    '----------------------------------------------------------------
    If Apci9131wOutportb(wBsn, APCI9131_PORT1, &H0) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
    '----------------------------------------------------------------
    ' tB^^CWX^1 (tB^ OFF)
    '----------------------------------------------------------------
    If Apci9131wSetFilter(wBsn, APCI9131_F_PORT1, &H0) = False Then
        ErrorMessage (wBsn)
        Exit Sub
    End If
End Sub
'====================================================================
' ʂ\
'====================================================================
Private Sub ResultMessage(lpszbuf As String)
    MsgBox lpszbuf, vbOKOnly + vbInformation, szTitle
End Sub
'====================================================================
' G[bZ[W\
'====================================================================
Private Sub ErrorMessage(ByVal bsn As Integer)
    Dim dwRes As Long
    Dim szBuf As String
    
    dwRes = Apci9131wGetLastError(bsn)
    Select Case dwRes
        Case APCI9131_ERR_WRAPDLL
            szBuf = "DLL Load error"
        Case Else
            szBuf = "aPCI-9131 error" + Chr(10) + Chr(10) + _
                    "Error code : &H" + Hex(dwRes)
    End Select
    
    MsgBox szBuf, vbOKOnly + vbCritical, szTitle
End Sub
