//===================================================================
// Apci9131w.h -- wrapper for C/C++
//-------------------------------------------------------------------
// Copyright (C) ADTEK System Science Co., Ltd.
//===================================================================
#include "Apci9131.h"

#ifdef __cplusplus
extern "C" {
#endif

#define APCI9131_DLL_NAME		_T( "Apci9131.dll" )	// DLL t@C
#define APCI9131_ERR_WRAPDLL	( (DWORD)-1 )			// bp[֐G[

BOOL  Apci9131wDllOpen( void );
BOOL  Apci9131wDllClose( void );

BOOL  Apci9131wGetVersion( PDWORD pdwDllVersion, PDWORD pdwDrvVersion );
BOOL  Apci9131wCreate( PWORD pwBsn, HWND hWnd, UINT uWMBase );
BOOL  Apci9131wClose( WORD wBsn );
BOOL  Apci9131wGetResource( WORD wBsn, PAPCI9131R pRes );
BOOL  Apci9131wGetSwitchValue( WORD wBsn, PBYTE pbValue );
BOOL  Apci9131wInitialize( WORD wBsn );
BOOL  Apci9131wSetTimer( WORD wBsn, DWORD dwCount );
BOOL  Apci9131wInportb( WORD wBsn, DWORD dwPort, PBYTE pData );
BOOL  Apci9131wOutportb( WORD wBsn, DWORD dwPort, BYTE Data );
BOOL  Apci9131wSetFilter( WORD wBsn, DWORD dwPort, BYTE Cnt );
BOOL  Apci9131wGetFilter( WORD wBsn, DWORD dwPort, PBYTE pCnt );
BOOL  Apci9131wSetIrPolarity( WORD wBsn, BYTE Pol );
BOOL  Apci9131wGetIrPolarity( WORD wBsn, PBYTE pPol );
BOOL  Apci9131wSetPortIr( WORD wBsn, BYTE Ir );
BOOL  Apci9131wGetPortIr( WORD wBsn, PBYTE pIr );
BOOL  Apci9131wSetStbAckIr( WORD wBsn, BYTE Ir );
BOOL  Apci9131wGetStbAckIr( WORD wBsn, PBYTE pIr );
BOOL  Apci9131wSetStbEnableRegs( WORD wBsn, BYTE Sen );
BOOL  Apci9131wGetStbEnableRegs( WORD wBsn, PBYTE pSen );
BOOL  Apci9131wSetAckMode( WORD wBsn, BYTE Ackm );
BOOL  Apci9131wGetAckMode( WORD wBsn, PBYTE pAckm );
BOOL  Apci9131wSetLedRegs( WORD wBsn, BYTE Led );
BOOL  Apci9131wGetLedRegs( WORD wBsn, PBYTE pLed );
BOOL  Apci9131wStbOut( WORD wBsn, BYTE Stb );
BOOL  Apci9131wAckOut( WORD wBsn, BYTE Ack );
DWORD Apci9131wGetLastError( WORD wBsn );

#ifdef __cplusplus
}
#endif
